Handlebars.registerHelper("each_list", function(ls, a, b) {
	var cond = null;
	var fn = a;

	if (typeof b == 'function') {
		fn = b;
		cond = a;
	}

	var rv = [];
	for (var i = 0; i < ls.length; i++) {
		var it = ls[i];

		it.index = i + 1;
		var v = fn(it);
		rv.push(v);
	}

	return rv.join("");
});

Handlebars.registerHelper("each_map", function(mp, a, b) {
	var cond = null;
	var fn = a;

	if (typeof b == 'function') {
		fn = b;
		cond = a;
	}

	var rv = [];
	for (var v in mp) {
		if (!mp.hasOwnProperty(v)) continue;
		if (v.indexOf('_') == 0 && v.lastIndexOf ('_') == v.length-1) continue;
		
		var it = mp[v];
		if (typeof it == 'string') {

			var o = {};
			o['_key_']   = v;
			o['_value_'] = it;
			o[v]         = it;

			var kn = '_' + v + '_path_';
			var kp = mp[kn];
			o[kn] = kp;

			it = o;
		}
		else {
			var o = {};
			o['_key_']   = v;
			o['_value_'] = it;
			o[v]         = it;

			var kn = '_' + v + '_path_';
			o[kn] = mp[kn];

			it = o;
		}

		if (cond != null) {
			try {
				if (eval("with (it) { " + cond + "}") == false) continue;
			}
			catch (ex) {
				console.log ("forEachMap:" + ex + " - " + cond);
				continue;
			}
		}

		var vv = fn(it);

		delete it._key_;
		delete it._value_;

		rv.push(vv);
	}

	return rv.join("");
});

Handlebars.registerHelper("non_empty", function(mp, fn) {
	for (var i = 0; i < (arguments.length - 1); i++) {
		var val = arguments[i];
		if (val != undefined && val != "") {
			return val;
		}
	}
	return "";
});

Handlebars.registerHelper("eval", function(cond, fn) {
	try {
		var rv = eval("with (this) { " + cond + "}");
		return rv;
	}
	catch (ex) {
		return "";
	}
});

Handlebars.registerHelper("log", function(text, fn) {
	console.log (text);
});

Handlebars.registerHelper("jcr_name", function(ctx, fn) {
	return $.__unfixName (ctx);
});

Handlebars.registerHelper("jcr_path", function(ctx, fn) {
	return this["_" + ctx + "_path_"];
});

Handlebars.registerHelper("trim", function(val, len, pad, fn) {
  if (!val) return "";
  if (val.length > len) {
		return val.substr (0, len);
	}
	else {
		return val;
	}
});

Handlebars.registerHelper("ltrim", function(val, len, pad, fn) {
  if (!val) return "";
  if (val.length > len) {
		if (pad) return pad + val.substr (val.length - len);
		else     return val.substr (val.length - len);
	}
	else {
		return val;
	}
});


Handlebars.registerHelper("wtrim", function(val, len, pad, fn) {
  if (!val) return "";
  if (val.length > len) {
    var l = val.split (' ');
    var x = 0;
    var s = [];
    for (var i = 0; i < l.length; i++) {
      x += l[i].length;
      if (x > len) {
        return s.join (' ') + pad;
      }
      else {
        s.push (l[i]);
      }
    }
  } else {
    return val;
  }
});

Handlebars.registerHelper ("url_encode", function (val) {
	return escape (val);
});


Handlebars.registerHelper ("date", function (val, format, func) {
	if (!val || val == "") return "";
	if (format == "DURATION") return durationFormat (val);
	var d = new Date (val);
	if (arguments.length == 3) return d.format (format);
	else return d.toString ();
});

Handlebars.registerHelper("dump", function(val, fn) {
  console.log (val);
});
	
Handlebars.registerHelper ("template", function (name, data, func) {
	if (typeof data == 'string') return;

	var source = $(name).html();
	
	if (!Handlebars._compiled_templates_[source]) {
		Handlebars._compiled_templates_[tmp] = Handlebars.compile(source);
	}

	var rv = Handlebars._compiled_templates_[source](data);
	rv = rv.replace (/(<[a-zA-Z0-9]+)/, '$1 data-template="' + name + '"');

	return new Handlebars.SafeString (rv);
});
